var google;
function CustomMarker(latlng, map, args) {
    this.latlng = latlng;
    this.args = args;
}

CustomMarker.prototype = new google.maps.OverlayView();

CustomMarker.prototype.draw = function () {
    let self = this;
    let divMarker = this.divMarker;
    
    if (!divMarker) {
    
        divMarker = this.divMarker = document.createElement('div');
        divMarker.className = 'custom_marker';

        if (typeof(self.args.value) !== 'undefined') {
            divMarker.innerHTML = self.args.value;
        }
        
        google.maps.event.addDomListener(divMarker, "click", function(event) {            
            google.maps.event.trigger(self, "click");
        });
        
        let panes = this.getPanes();
        panes.overlayImage.appendChild(divMarker);
    }
    
    let point = this.getProjection().fromLatLngToDivPixel(this.latlng);
    
    if (point) {
        divMarker.style.left = point.x + 'px';
        divMarker.style.top = (point.y - 15) + 'px';
    }
}

CustomMarker.prototype.remove = function () {
    if (this.divMarker) {
        this.divMarker.parentNode.removeChild(this.divMarker);
        this.divMarker = null;
    }
}

CustomMarker.prototype.getPosition = function () {
    return this.latlng;
}